diff -urB kaffe/libraries/javalib/java/awt/Color.java patched-kaffe/libraries/javalib/java/awt/Color.java
--- kaffe/libraries/javalib/java/awt/Color.java	Wed Apr 18 11:31:33 2001
+++ patched-kaffe/libraries/javalib/java/awt/Color.java	Sun Mar  3 14:48:59 2002
@@ -286,8 +286,8 @@
 }
 
 public String toString() {
-	return "Color [r=" + getRed() + 
+	return "java.awt.Color[r=" + getRed() + 
 	             ",g=" + getGreen() +
-	             ",b=" + getBlue() + "]";
+	             ",b=" + getBlue() + ']';
 }
 }
diff -urB kaffe/libraries/javalib/java/awt/Component.java patched-kaffe/libraries/javalib/java/awt/Component.java
--- kaffe/libraries/javalib/java/awt/Component.java	Thu Feb 28 22:54:10 2002
+++ patched-kaffe/libraries/javalib/java/awt/Component.java	Sun Mar  3 14:59:20 2002
@@ -913,9 +913,9 @@
 protected String paramString () {
 	String s = name + ',' + x + ',' + y + ',' + width + 'x' + height;
 	
-	if ( !isValid() )   s += " invalid";	
-	if ( !isVisible() ) s += " hidden";
-	if ( !isEnabled() ) s += " disabled";
+	if ( !isValid() )   s += ",invalid";	
+	if ( !isVisible() ) s += ",hidden";
+	if ( !isEnabled() ) s += ",disabled";
 	
 	return s;
 }
diff -urB kaffe/libraries/javalib/java/awt/Dimension.java patched-kaffe/libraries/javalib/java/awt/Dimension.java
--- kaffe/libraries/javalib/java/awt/Dimension.java	Wed Mar 24 08:56:19 1999
+++ patched-kaffe/libraries/javalib/java/awt/Dimension.java	Sun Mar  3 15:02:50 2002
@@ -58,6 +58,6 @@
 }
 
 public String toString() {
-	return getClass().getName() + " [" + width + ',' + height + ']';
+	return getClass().getName() + "[width=" + width + ",height=" + height + ']';
 }
 }
diff -urB kaffe/libraries/javalib/java/awt/Font.java patched-kaffe/libraries/javalib/java/awt/Font.java
--- kaffe/libraries/javalib/java/awt/Font.java	Sun Nov 25 21:52:00 2001
+++ patched-kaffe/libraries/javalib/java/awt/Font.java	Sun Mar  3 14:56:01 2002
@@ -216,6 +216,7 @@
 		if ( (style & ITALIC) != 0 ) s += "italic";
 	}
 
-	return getClass().getName() + " [" + name + ',' +	s + ',' + size + ']';
+	return getClass().getName() + "[family=" +getFamily() + ",name=" + name
+	    + ",style=" + s + ",size=" + size + ']';
 }
 }
diff -urB kaffe/libraries/javalib/java/awt/Insets.java patched-kaffe/libraries/javalib/java/awt/Insets.java
--- kaffe/libraries/javalib/java/awt/Insets.java	Mon Aug 16 00:29:46 1999
+++ patched-kaffe/libraries/javalib/java/awt/Insets.java	Sun Mar  3 15:00:09 2002
@@ -74,7 +74,7 @@
 
 public String toString() {
 	return getClass().getName() 
-		+ " [top="  + top + ",left=" + left
+		+ "[top="  + top + ",left=" + left
 		+ ",bottom=" + bottom + ",right=" + right + ']';
 }
 }
diff -urB kaffe/libraries/javalib/java/awt/MenuItem.java patched-kaffe/libraries/javalib/java/awt/MenuItem.java
--- kaffe/libraries/javalib/java/awt/MenuItem.java	Sun Mar  3 14:30:32 2002
+++ patched-kaffe/libraries/javalib/java/awt/MenuItem.java	Sun Mar  3 16:02:28 2002
@@ -25,6 +25,7 @@
 	String aCmd;
 	int eventMask;
 	static MenuItem separator = new MenuItem( "-");
+	private static int counter;
 	final private static long serialVersionUID = -21757335363267194L;
 
 public MenuItem() {
@@ -39,6 +40,7 @@
 	setShortcut( s);
 	setLabel( label);
 	setFont( defFnt);
+	setName("menuitem" + counter++);
 }
 
 public synchronized void addActionListener( ActionListener l) {
diff -urB kaffe/libraries/javalib/java/awt/Point.java patched-kaffe/libraries/javalib/java/awt/Point.java
--- kaffe/libraries/javalib/java/awt/Point.java	Wed Mar 24 05:06:44 1999
+++ patched-kaffe/libraries/javalib/java/awt/Point.java	Sun Mar  3 16:07:44 2002
@@ -75,7 +75,7 @@
 }
 
 public String toString() {
-	return getClass().getName() + " [" + x + ',' + y + ']';
+	return getClass().getName() + "[x=" + x + ",y=" + y + ']';
 }
 
 public void translate ( int xDelta, int yDelta ) {
diff -urB kaffe/libraries/javalib/java/awt/PopupMenu.java patched-kaffe/libraries/javalib/java/awt/PopupMenu.java
--- kaffe/libraries/javalib/java/awt/PopupMenu.java	Sat Jul 24 02:56:13 1999
+++ patched-kaffe/libraries/javalib/java/awt/PopupMenu.java	Sun Mar  3 16:10:16 2002
@@ -16,6 +16,7 @@
   extends Menu
 {
 	final private static long serialVersionUID = -4620452533522760060L;
+	private static int counter;
 	PopupWindow wnd;
 
 public PopupMenu() {
@@ -23,12 +24,14 @@
 }
 
 PopupMenu ( Menu m) {
-	super(m.label);
+	this(m.getLabel());
 	items = m.items;
 }
 
 public PopupMenu( String label) {
 	super( label);
+
+	setName("popup" + counter++);
 }
 
 void dispose() {
diff -urB kaffe/libraries/javalib/java/awt/Rectangle.java patched-kaffe/libraries/javalib/java/awt/Rectangle.java
--- kaffe/libraries/javalib/java/awt/Rectangle.java	Wed Mar 24 08:56:20 1999
+++ patched-kaffe/libraries/javalib/java/awt/Rectangle.java	Sun Mar  3 16:11:27 2002
@@ -240,8 +240,8 @@
 }
 
 public String toString() {
-	return getClass().getName() + " [" + x + ',' + y +
-	                              " "  + width + ',' + height + ']';
+	return getClass().getName() + "[x=" + x + ",y=" + y +
+	                              ",width="  + width + ",height=" + height + ']';
 }
 
 public void translate ( int xDelta, int yDelta ) {
diff -urB kaffe/libraries/javalib/java/awt/Window.java patched-kaffe/libraries/javalib/java/awt/Window.java
--- kaffe/libraries/javalib/java/awt/Window.java	Wed Dec 19 23:21:34 2001
+++ patched-kaffe/libraries/javalib/java/awt/Window.java	Sun Mar  3 16:12:49 2002
@@ -24,6 +24,7 @@
 	WindowListener wndListener;
 	Frame owner;
 	static Window dummy = new Window();
+	private static int counter;
 	final private static long serialVersionUID = 4497834738069338734L;
 
 Window () {
@@ -35,6 +36,7 @@
 	font  = Defaults.WndFont;
 
 	setLayout(new BorderLayout());
+	setName("win" + counter++);
 }
 
 public Window ( Frame owner ) {
diff -urB kaffe/libraries/javalib/java/awt/datatransfer/DataFlavor.java patched-kaffe/libraries/javalib/java/awt/datatransfer/DataFlavor.java
--- kaffe/libraries/javalib/java/awt/datatransfer/DataFlavor.java	Sun Dec 16 17:38:17 2001
+++ patched-kaffe/libraries/javalib/java/awt/datatransfer/DataFlavor.java	Sun Mar  3 16:16:16 2002
@@ -111,6 +111,9 @@
 }
 
 public String toString() {
-	return "DataFlavor [" + name + ',' + type + ',' + repClass.getName() + ']';
+	return getClass().getName()
+	    + "[representationclass=" + getRepresentationClass().getName()
+	    + ",mimetype=" + getMimeType()
+	    + ']';
 }
 }
diff -urB kaffe/libraries/javalib/java/io/InvalidClassException.java patched-kaffe/libraries/javalib/java/io/InvalidClassException.java
--- kaffe/libraries/javalib/java/io/InvalidClassException.java	Sun Dec 16 17:46:02 2001
+++ patched-kaffe/libraries/javalib/java/io/InvalidClassException.java	Sun Mar  3 16:20:19 2002
@@ -32,7 +32,7 @@
 
 public String getMessage()
 	{
-	if (classname != null) {
+	if (classname != null && !classname.equals("")) {
 	        return (classname + SEPARATOR + super.getMessage());
 	}
 	else {